Subject: Re: [bitcoin-dev] Is there a tool like Ethereum EVM at present for Bitcoin script?

From: Null Null <[email-masked]>
Date: Thu, 26 Aug 2021 10:43:27 +0800

thanks for you suggestion, Gijs.

I spent some time learning miniscript, and there are some problems that need to confirm for me:

1. Is miniscript a brand new Bitcoin scripting language?
2. If I use miniscript, do I need to compile it into a Bitcoin OP_CODE script? If so, how to do that ? has someone written a compiler? 
I found that @sipa has open sourced a compiler implemented in C++ on github( https://github.com/sipa/miniscript ). This should translate the policy language into miniscript;

> 2021年8月24日 下午3:36，Gijs van Dam via bitcoin-dev <[email-masked]> 写道：
> 
> Hi,
> 
> 
> Bitcoin does not have a virtual machine. But you do have [Miniscript][1], [Min.sc][2], [Simplicity][3] and [Sapio][4]. These are all higher level languages that compile to Bitcoin Script. Sapio is "just" Rust, so that might fit your setting best.
> 
> By the way, this question also has an answer on [Bitcoin Stackexchange][5] which is a great resource for questions like this.
> 
> [1]: http://bitcoin.sipa.be/miniscript/
> [2]: https://min.sc/
> [3]: https://github.com/ElementsProject/simplicity
> [4]: https://learn.sapio-lang.org/
> [5]: https://bitcoin.stackexchange.com/questions/108261/is-there-a-tool-like-ethereum-evm-at-present-for-bitcoin-script
> 
> On Tue, Aug 24, 2021 at 2:55 PM Null Null via bitcoin-dev <[email-masked]> wrote:
> Hi all,
> 
> Is there a tool like Ethereum EVM at present? Users can write bitcoin scripts in a syntax just like python(or like other programming language); through this tool, they can be translated into bitcoin original scripts; it sounds like a new programming language has been invented.
> 
> In my opinion， Bitcoin script programming is based on reverse Polish expression; this is not friendly to programmers;
> 
> In fact, Bitcoin's opcode expression ability is very rich, and it may be unfriendly, which has affected the promotion of Bitcoin in the technical community.
> 
> Hope for hearing some voice about this.
> 
> Best wish.
> 
> _______________________________________________
> bitcoin-dev mailing list
> [email-masked]
> https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
> _______________________________________________
> bitcoin-dev mailing list
> [email-masked]
> https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev